//*****************************************************************************
// File Name            : sdram_rd_abt.v
//-----------------------------------------------------------------------------
// Function             : sd-ramւ̃[hANZX̒ 
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//-----------------------------------------------------------------------------
// History
// -.-- 2012/07/31
// -.-- 2012/08/17
//*****************************************************************************
module sdram_rd_abt (
  clk,
  reset_n,       
  l_u_rreq,   
  l_u_rack,    
  l_u_radr,    
  l_u_rd_da_en,    
  l_u_rd_da,        
  s_u_rreq,   
  s_u_rack,    
  s_u_radr,    
  s_u_rd_da_en,    
  s_u_rd_da,   
  u_rreq,   
  u_rack,    
  u_radr,    
  u_rd_da_en,    
  u_rd_da
);

  input clk;
  input reset_n;
  input l_u_rreq;        //user read req
  output l_u_rack;       //user read ack
  input [19:0]l_u_radr; //user read address
  output l_u_rd_da_en;     //user read  enable
  output [15:0]l_u_rd_da; //user read  data
  input  s_u_rreq;        //user read req
  output s_u_rack;       //user read ack
  input [19:0]s_u_radr; //user read address
  output s_u_rd_da_en;     //user read  enable
  output [15:0]s_u_rd_da; //user read  data

   
  output u_rreq;        //user read req
  input u_rack;       //user read ack
  output [19:0]u_radr; //user read address
  input u_rd_da_en;     //user read  enable
  input [15:0]u_rd_da; //user read  data

  parameter  p_idle   = 2'b0;   
  parameter  p_sel_l  = 2'd1;  
  parameter  p_sel_s  = 2'd2;   
   
  reg [1:0]   state;
  reg         u_rd_da_en_d1;
   
  
//Xe[g}V  
always @ (posedge clk or negedge reset_n )
if (reset_n==1'b0)
  begin
    state <= p_idle;
  end
else
  case (state)
    //-------------------------------------------------
    p_idle:begin
        if (l_u_rreq==1'b1) 
          state <= p_sel_l;
        else if(s_u_rreq==1'b1) 
          state <= p_sel_s;
        else
          state <= p_idle;
    end // 
    //-------------------------------------------------
     p_sel_l:begin
        if ((u_rd_da_en==1'b0)&&(u_rd_da_en_d1==1'b1))
          state <= p_idle;
        else
          state <= p_sel_l;
      end // 
    //-------------------------------------------------
     p_sel_s:begin
        if ((u_rd_da_en==1'b0)&&(u_rd_da_en_d1==1'b1))
          state <= p_idle;
        else
          state <= p_sel_s;
      end // 
    //-------------------------------------------------
     default:begin
        state <= p_idle;
    end // 
  endcase
   
always @ (posedge clk or negedge reset_n )
if (reset_n==1'b0)
  u_rd_da_en_d1  <= 1'b0;
else
  u_rd_da_en_d1  <= u_rd_da_en;
  

assign u_rreq = (state== p_sel_l)?l_u_rreq:  
                (state== p_sel_s)?s_u_rreq:1'b0;
   
assign u_radr = (state== p_sel_l)?l_u_radr:  
                (state== p_sel_s)?s_u_radr:20'd0;
  
assign  l_u_rack = (state== p_sel_l)?u_rack:1'b0;
assign  l_u_rd_da_en = (state== p_sel_l)?u_rd_da_en:1'b0;
assign  l_u_rd_da = (state== p_sel_l)?u_rd_da:16'h0000;

assign  s_u_rack = (state== p_sel_s)?u_rack:1'b0;
assign  s_u_rd_da_en = (state== p_sel_s)?u_rd_da_en:1'b0;
assign  s_u_rd_da = (state== p_sel_s)?u_rd_da:16'h0000;


endmodule








